
#import <UIKit/UIKit.h>
#import "Sprite.h"
#import "Zombie.h"
#import "Player.h"
#import "Car.h"
#import "Car_180.h"
#import "CarDrawer.h"
#import "Animation.h"

extern int W; 
extern int H;

extern int state; 

enum states {
    LOAD_GAME,
    START_GAME,
    PLAY_GAME,
    GAME_OVER,
    GAME_WON,
    HIGHSCORES
}; 

@interface GameManager : NSObject {
    UIImage *background;
    Zombie *guy;
    Player *player;
    UIImage *blood;
    
    NSMutableDictionary* array;
    
    NSNumber *score;
    NSDate* date;
    NSDateFormatter *dateFormatter;
    NSString *dateString;
    NSMutableDictionary *highscores;
    NSString *highscoresKey;
    NSArray *keys;
    NSNumber *scoreObj;
    NSMutableDictionary *deleteAr;
    
    NSMutableArray *sprites; //Aktive Sprites, die gerendert werden sollen
    NSMutableArray *newSprites; //Neue Sprites, die der sprites-Liste hinzugefügt werden sollen
    NSMutableArray *destroyableSprites; //Inaktive Sprites, die gelöscht werden sollen     
    NSMutableDictionary* dictionary; //Ressourcen-Hashtable
    
    int saved;      //Anzahl der 'geretteten' Zombies    
    int lost;       //Anzahl der 'überfahrenen' Zombies
    int savedMax;   //Gewinnbedingung
}

//Init Methods
+ (GameManager *) getInstance;
- (void) preloader;
- (void) loadGame;
- (void) createSprite: (int) type 
                speed: (CGPoint) sxy 
                  pos: (CGPoint) pxy;
- (void) createExplosionFor: (Sprite *) sprite;

//Game Handler
- (void) touchBegan: (CGPoint) p;
- (void) touchMoved: (CGPoint) p;
- (void) touchEnded;
- (void) handleStates;
- (void) drawStatesWithFrame: (CGRect) frame; 
- (void) savedZombie; 
- (void) lostZombie;
- (void) playGame; 
- (void) checkSprite: (Sprite *) sprite;

//Helper Methods
- (void) setState: (int) stt;
- (void) saveObject: (id) object key: (NSString *) key;
- (id)readObjectforKey:(NSString *)key;
- (void) manageSprites;
- (void) renderSprites;
- (int) getRndBetween: (int) bottom and: (int) top;
- (void) drawString: (NSString *) str at: (CGPoint) p;
- (NSMutableDictionary*) getDictionary;
- (UIImage *) getPic: (NSString*) picName;
- (NSString *)imageRnd;
- (NSString *)imageRnd_180;
- (void) drawTargetLine;
- (void)saveScore;
- (NSNumber*) changeNumber;
- (int) getTargetX;
- (void)save;

@end
