
#import "MyGameAppDelegate.h"

@implementation MyGameAppDelegate

- (void)applicationDidFinishLaunching:(UIApplication *)application {     
    mainView = [[MainView alloc] initWithFrame: [UIScreen mainScreen].applicationFrame]; 
    mainView.backgroundColor = [UIColor grayColor];
    [window addSubview: mainView];
    [window makeKeyAndVisible];
    if (state == GAME_WON) {
        [[GameManager getInstance] loadGame];
    }
}

- (void) startGameLoop {    
    NSString *deviceOS = [[UIDevice currentDevice] systemVersion];    
    NSTimeInterval fps = 0.033;
    bool forceTimerVariant = TRUE;
    
    if (forceTimerVariant || [deviceOS compare: @"3.1" options: NSNumericSearch] == NSOrderedAscending) {
        timer = [NSTimer scheduledTimerWithTimeInterval: fps
                                                 target: self
                                               selector: @selector( loop )
                                               userInfo: nil
                                                repeats: YES]; 
    
    } else {
        timer = [NSClassFromString(@"CADisplayLink") displayLinkWithTarget: self selector: @selector( loop )];
        [timer setFrameInterval: fps];
        [timer addToRunLoop: [NSRunLoop currentRunLoop] forMode: NSDefaultRunLoopMode];
    }
    
    NSLog(@"Game Loop timer instance: %@", timer);   
}

- (void) stopGameLoop {
    [timer invalidate];
    timer = nil;
}

- (void) loop {
	mainView.setNeedsDisplay; //triggers MainView's drawRect:-method	
}

- (void) applicationDidBecomeActive: (UIApplication *) application {
    [self startGameLoop];
}

- (void) applicationWillResignActive: (UIApplication *) application {
    [self stopGameLoop];
}

- (void) dealloc {
    [self stopGameLoop];
    [timer release];
    [window release];
    [mainView release];
    [super dealloc];
}

@end
