
#import <UIKit/UIKit.h>

//Sprite-Typen 
enum types {    
    PLAYER,
    ZOMBIE,
    CAR,
    CAR_180,
    ANIMATION,
    REANIMATOR
};

@interface Sprite : NSObject {    
    UIImage *pic;       //Filmstreifen mit Frames
    CGPoint speed;      //Pixelgeschwindigkeit pro Frame in x-, y-Richtung
    CGPoint pos;        //aktuelle Position
    int cnt;            //interner Zaehler    
    int frameNr;        //aktuelles Frame
    int frameCnt;       //Anzahl Frames im Filmstreifen       
    int frameStep;      //Anzahl Frames pro Durchlauf  
    int frameW;         //Breite eines Frames
    int frameH;         //Höhes eines Frames
    int type;           //Sprite-Typ
    int cycleCnt;       //Anzahl der Wiederholungen des Filmstreifens
    bool forceIdleness; //keine Animation, wenn Sprite stillsteht
    bool active;        //inaktive Sprites werden vom GameManager gelöscht
}

-(id) initWithPic: (NSString *) picName 
         frameCnt: (int) fcnt 
        frameStep: (int) fstp
            speed: (CGPoint) sxy 
              pos: (CGPoint) pxy;
- (void) draw;
- (void) drawFrame;
- (void) renderSprite;
- (int) updateFrame;
- (CGRect) getRect;
- (bool) checkColWithPoint: (CGPoint) p;
- (bool) checkColWithSprite: (Sprite *) sprite;
- (void) hit;
- (void) setType: (int) spriteType;
- (int) getType;
- (void) setSpeed: (CGPoint) sxy;
- (CGPoint) getSpeed;
- (bool) isActive;

@end
