
#import "Zombie.h"
#import "GameManager.h"

int picRND;
int count;

bool bloodBool = false;

CGPoint p;

@implementation Zombie

+ (Zombie*) getZombieInstance  {
    
    static Zombie* zombie;
    
	if (!zombie) {
        zombie = [[Zombie alloc] init];
        NSLog(@"gameManager Singleton angelegt!");           
	}
    
    return zombie;
}


- (id) initWithPic: (NSString *) picName 
          frameCnt: (int) fcnt 
         frameStep: (int) fstp
             speed: (CGPoint) sxy 
               pos: (CGPoint) pxy {     
    
    self = [super initWithPic: picName 
                     frameCnt: fcnt 
                    frameStep: fstp
                        speed: sxy
                          pos: pxy];    
    
    argghPic = [[GameManager getInstance] getPic: @"arggh.png"];
    savedImage = [[GameManager getInstance] getPic:@"saved.png"];
    
    forceIdleness = true;
    hitCnt = 0;
    touchAction = false;
    saved = false;
    return self;
}

- (bool)isActive {
    return active;
}

- (void) draw {
    UIImage *playerShadow = [UIImage imageNamed:@"player_SH.png"];
    [playerShadow drawAtPoint: pos];
    [super draw];
    
    //Stop movement
    if (speed.x > 0 && touchPoint.x < pos.x) speed.x = 0;
    if (speed.x < 0 && touchPoint.x > pos.x) speed.x = 0;
    if (speed.y > 0 && touchPoint.y < pos.y) speed.y = 0;
    if (speed.y < 0 && touchPoint.y > pos.y) speed.y = 0;
    
    /* Licht Signal ON / OFF
    if (pos.x >= 60 && pos.x <= W/2+60) {
        UIImage *LightSingnalGo = [UIImage imageNamed:@"LichtSignalGo.png"];
        [LightSingnalGo drawAtPoint: CGPointMake(W -55, H/2-70)];
        [LightSingnalGo release];
    } else if (pos.x >= W/2+60 && pos.x <= W-60) {
        UIImage *LightSingnalSelf = [UIImage imageNamed:@"LichtSignalSelfAtention.png"];
        [LightSingnalSelf drawAtPoint: CGPointMake(W -55, H/2-70)];
        [LightSingnalSelf release];
    } else {
        UIImage *LightSingnalWait = [UIImage imageNamed:@"LichtSignalWait.png"];
        [LightSingnalWait drawAtPoint: CGPointMake(W -55, H/2-70)];
        [LightSingnalWait release]; 
    }*/
    
    if (pos.x >= 264) {
        [savedImage drawAtPoint: CGPointMake(pos.x, pos.y - argghPic.size.height)];
    } else if (pos.x <= 22) {
        [self setSpeed:CGPointMake(1, 0)];
    }
    
    if (pos.x > [[GameManager getInstance] getTargetX]) {
        saved = true;
        [self setSpeed: CGPointMake(3, 0)];
        if (pos.x > W) {
            
            [[GameManager getInstance] savedZombie];
            active = false;
        }
        
    } else {
        saved = false;
    }
}

- (void) hit {
    if (!saved) {
        hitCnt++;
        [argghPic drawAtPoint: CGPointMake(pos.x, pos.y - argghPic.size.height)];
        p = CGPointMake(pos.x, pos.y);
        if (hitCnt == 1) {
            active = false;
            bloodBool = true;
            [[GameManager getInstance] lostZombie];
            [[GameManager getInstance] createExplosionFor: self];
        } 
    }
}

- (void) setTouch: (CGPoint) point {
    if ([self checkColWithPoint: point]) {
        touchAction = true;
    }
    if (touchAction && !saved) {
        touchPoint = point;
        speed.x = (touchPoint.x - pos.x); //deltaX
        //speed.y = (touchPoint.y - pos.y)/20; //deltaY  
    }
}

- (void) touchEnded {
    touchAction = false;    
}
- (int) getRndBetween: (int) bottom and: (int) top {		
	int rnd = bottom + (arc4random() % (top+1-bottom)); 
	return rnd;
} 


@end
